![Framefox](./docs/images/framefox.png?raw=true "Framefox")

# Swift, smart, and a bit foxy!

Framefox is a modern Python web framework designed to make web development enjoyable and productive.

![Demo](./docs/images/demo.gif)

## Documentation 
Our comprehensive documentation is available [here](https://soma-smart.github.io/doc-framefox/) 📖

## Features

- **Object-oriented framework**: Built with an object-oriented approach, providing a structured and organized way to build your web applications
- **Simplified development**: Designed to simplify the development of robust, modular, and maintainable applications
- **Clear MVC architecture**: Emphasizes a clear Model-View-Controller (MVC) architecture for better code organization and separation of concerns
- **Productivity-driven philosophy**: Focuses on enhancing developer productivity with its intuitive structure and features

Key features include an interactive terminal, a powerful routing system, advanced configuration management, pre-configured authentication and registration, ORM database management, and much more.

Dive into the documentation to discover how Framefox can transform your Python development experience.

## Contributing

We welcome contributions! Please read our [Contributing Guide](./CONTRIBUTING.md) to get started.

## License

This project is licensed under the MIT License - see the [LICENSE](./LICENSE) file for details.

## Authors

- **BOUMAZA Rayen** - [@RayenBou](https://github.com/RayenBou)
- **LEUROND Raphaël** - [@Vasulvius](https://github.com/Vasulvius)

---

**Swift, smart, and a bit foxy!** - Framefox makes Python web development enjoyable and productive.